#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>


#define N (1<<13)
#define map(i,j) ((j)+N*(i))
#define B (1<<4)


void print_timediff(struct timespec ts_start,struct timespec ts_end){
  struct timespec ts_diff;
    
  ts_diff.tv_sec = ts_end.tv_sec - ts_start.tv_sec;
  ts_diff.tv_nsec = ts_end.tv_nsec - ts_start.tv_nsec;
  if (ts_diff.tv_nsec > 1000000000) {
    ts_diff.tv_sec++;
    ts_diff.tv_nsec -= 1000000000;
  }
  if (ts_diff.tv_nsec < 0) {
    ts_diff.tv_sec--;
    ts_diff.tv_nsec += 1000000000;
  }
  
  fprintf(stderr,"Elapsed time: %.3f sec\n ", ts_diff.tv_sec+(1.0e-9)*ts_diff.tv_nsec);
}




void main (void){
  int i,j;
  int ib,jb;
  double *a = (double*)malloc(N*N*sizeof(double));
  double *b = (double*)malloc(N*N*sizeof(double));
  double tmp;
  unsigned short seed[3];
  struct timespec ts_start;
  struct timespec ts_end;


  seed[0] = 123;
  seed[1] = 456;
  seed[2] = 789;
  seed48(seed);
  for (i=0;i<N*N;i++) a[i] = drand48()-0.5;

  clock_gettime(CLOCK_MONOTONIC, &ts_start);
  tmp = 0.0;

  for (i=0;i<N;i++){
    for (j=0;j<N;j++){
      b[map(i,j)] = a[map(j,i)];
    }
  }
  clock_gettime(CLOCK_MONOTONIC, &ts_end);
  for (i=0;i<N*N;i++) tmp+=b[i]; // prevents code elimination by the compiler
  print_timediff(ts_start,ts_end);
  fprintf(stderr,"sum = %.16f\n",tmp);


  fprintf(stderr,"\n");

  clock_gettime(CLOCK_MONOTONIC, &ts_start);
  tmp = 0.0;

  for (jb=0;jb<N;jb+=B){
    for (i=0;i<N;i++){
      for (j=0;j<B;j++){
	b[map(i,j+jb)] = a[map(j+jb,i)];
      }
    }
  }
  clock_gettime(CLOCK_MONOTONIC, &ts_end);
  for (i=0;i<N*N;i++) tmp+=b[i]; // prevents code elimination by the compiler
  print_timediff(ts_start,ts_end);
  fprintf(stderr,"sum = %.16f\n",tmp);
  

}
