#include <bits/stdc++.h>

using namespace std;
using namespace std::chrono;

int main()
{
  const long int N = 500000; //Array Size
  const long int noTests = 5000; //Number of tests
  float a[N],b[N],c[N],result[N];

  for (int i = 0; i < N; ++i)  //Data initialization	
    { 
      a[i] =       ((float)i)+ 0.1335f; 
      b[i] = 1.50f*((float)i)+ 0.9383f; 
      c[i] = 0.33f*((float)i)+ 0.1172f; 
    }    

  auto now = high_resolution_clock::now();
  for (int i = 0; i < noTests; ++i) 
    for (int j = 0; j < N; ++j)
      {
	result[j] = a[j]+b[j]-c[j]+3*(float)i;
      }
  auto end_time = duration_cast<duration<double>>(high_resolution_clock::now() - now).count();
  assert( result[2] == ( 2.0f + 0.1335f)+( 1.50f*2.0f + 0.9383f)-(0.33f*2.0f+0.1172f)+3*(float)(noTests-1));
  cout << "Time used: "<< end_time << "sec,   N * noTests="<<(N*noTests)<< endl;
  cout << "\n" << endl;

  
  auto now2 = high_resolution_clock::now();
  for (int i = 0; i < noTests; ++i)
    {
      result[0] = 1.0;
      for (int j = 1; j < N; ++j)
	{
	  result[j] = 1.0/(1.0+a[j]);
	}
    }
  auto end_time2 = duration_cast<duration<double>>(high_resolution_clock::now() - now2).count();
  cout << "Result   : "<< result[N-1] << endl;
  cout << "Time used: "<< end_time2 << "sec,   N * noTests="<<(N*noTests)<< endl;
  cout << "\n" << endl;


  
  auto now1 = high_resolution_clock::now();
  for (int i = 0; i < noTests; ++i)
    {
      result[0] = 1.0;
      for (int j = 1; j < N; ++j)
	{
	  result[j] = 1.0/(1.0+result[j-1]);
	}
    }
  auto end_time1 = duration_cast<duration<double>>(high_resolution_clock::now() - now1).count();
  cout << "Result   : "<< result[N-1] << endl;
  cout << "Time used: "<< end_time1 << "sec,   N * noTests="<<(N*noTests)<< endl;
  cout << "\n" << endl;

  
  
  auto now3 = high_resolution_clock::now();
  for (int i = 0; i < noTests; ++i)
    {
      result[0] = 1.0;
      result[2] = 1.0;
      result[3] = 1.0;
      for (int j = 4; j < N; ++j)
	{
	  result[j] = 1.0/(1.0+result[j-4]);
	}
    }
  auto end_time3 = duration_cast<duration<double>>(high_resolution_clock::now() - now3).count();
  cout << "Result   : "<< result[N-1] << endl;
  cout << "Time used: "<< end_time3 << "sec,   N * noTests="<<(N*noTests)<< endl;

  
  return 0;
}
